Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able.data
Class AbleCategoricalField

    java.lang.Object
      com.ibm.able.data.AbleLhs
          com.ibm.able.data.AbleVariable
              com.ibm.able.data.AbleTypedVariable
                  com.ibm.able.data.AbleCategoricalVariable
                      com.ibm.able.data.AbleCategoricalField

All Implemented Interfaces:
  AbleClearable, AbleField, AbleRd, AbleWr, java.io.Serializable

public class AbleCategoricalField
extends AbleCategoricalVariable
implements AbleField

Categorical fields are String fields with a finite set of possible values.

See Also:
  Serialized Form

Field Summary
`protected int` | `column` An index representing this field's position in a record.
`protected java.util.Hashtable` | `table` A Hashtable where the key is an Integer value representing an element in a dictionary; the object is one String value in the dictionary.
`protected int` | `usage` Values representing input, output, or ignore.

Fields inherited from class com.ibm.able.data.AbleCategoricalVariable
`myInitialValue, myValue, myValueList`

Fields inherited from class com.ibm.able.data.AbleTypedVariable
`myDataTypeClass, myDataTypeClassName, myDataTypeName, myInitialParms`

Fields inherited from class com.ibm.able.data.AbleVariable
`myBoundFlag, myChgSupport, myComment, myContext, myDataType, myGlobalFlag, myId, myName, myPrompt, myReferences, myStaticFlag, myTemplateFlag, myValueInitial`

Constructor Summary
`AbleCategoricalField(AbleFieldDefinition def)` Construct a Categorical field.
`AbleCategoricalField(java.lang.String name, int usageType, int column)` Construct a Categorical field.

Method Summary
`void` | `computeStatistics(java.lang.Object inValue)` Add unique symbols to a symbol table and maintain a dictionary of legal values.
`int` | `getColumn()` Get the column index position of this field in a record.
`java.lang.String` | `getDataTypeString()` Get the data type of this field as a string - "continuous" for example.
`AbleTranslateTemplate` | `getInputTranslateTemplate()` Provide an input translate template for this field.
`java.util.Map` | `getMap()` Get the Map of all unique values that are possible for this field.
`int` | `getNormalizedSize()` Return the number of unique categories for 1 of N code.
`double` | `getNumericValue(java.lang.Object inValue)` Translate a value into an index in the dictionary.
`AbleTranslateTemplate` | `getOutputTranslateTemplate()` Provide an output translate template for this field.
`int` | `getUsage()` Get the usage type of this field - "input" for example.
`java.lang.String` | `getUsageString()` Get the usage type of this field as a string - "input" for example.
`void` | `setColumn(int col)` Set the index position in the record, based on field definition order.
`void` | `setUsage(java.lang.String usage)` Set the usage type of this from a string - "input" for example.

Methods inherited from class com.ibm.able.data.AbleCategoricalVariable
`addValue, arlDclString, armlDclString, asgnEq, cmpEq, cmpGt, cmpGtEq, cmpLt, cmpLtEq, cmpNeq, compPlus, createInitializer, getBooleanValue, getDataTypeClass, getDataTypeClassName, getFuzzyValue, getGenericValue, getIndexOf, getLiteralClass, getNumericValue, getRawValue, getStringValue, getValue, getValueAt, getValueList, getValueListSize, getValueString, init, removeValue, reset, setBooleanValue, setFuzzyValue, setGenericValue, setInitialValue, setNumericValue, setStringValue, setValue, setValueList, setValueString, toString, traceString, valueExist, xmlDclString`

Methods inherited from class com.ibm.able.data.AbleTypedVariable
`clear, cmpIs, compDivide, compMinus, compMultiply, compUnaryMinus, getDataTypeName, replaceValues`

Methods inherited from class com.ibm.able.data.AbleVariable
`arlCRdString, arlInitializerString, armlCRdString, armlInitializerString, getArlComment, getChgSupport, getComment, getContext, getDataType, getDataTypeAsString, getId, getName, getPrompt, getPromptString, getReferences, getReferent, getReferents, getTemplateString, isBound, isConstant, isGlobal, isLocal, isStatic, isTemplate, notStatic, setChgSupport, setComment, setContext, setId, setPrompt, setReferences, setStatic, setTemplate, xmlCRdString, xmlCWrString, xmlInitializerString`

Methods inherited from class com.ibm.able.data.AbleLhs
`asgnIs, asgnIs, bitwiseAND, bitwiseNOT, bitwiseOR, bitwiseShiftLeft, bitwiseShiftRight, bitwiseShiftRightZeroFill, bitwiseXOR, compModulo, logicalAND, logicalNOT, logicalOR`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.ibm.able.data.AbleField
`getName, getStringValue`

Field Detail

### usage

    protected int usage

  Values representing input, output, or ignore.

### column

    protected int column

  An index representing this field's position in a record.

### table

    protected java.util.Hashtable table

  A Hashtable where the key is an Integer value representing an element in a dictionary; the object is one String value in the dictionary.

Constructor Detail

### AbleCategoricalField

    public AbleCategoricalField(AbleFieldDefinition def)

  Construct a Categorical field. Must call setColumn to set the position in the record.

Parameters:
  `def` - An AbleFieldDefinition which provides the name and usage for this field.

### AbleCategoricalField

    public AbleCategoricalField(java.lang.String name,
                                int usageType,
                                int column)

  Construct a Categorical field.

Parameters:
  `name` - The field name.
  `usageType` - The usage type, one of `AbleData.InputUsage`, `AbleData.OutputUsage`, or `AbleData.IgnoreUsage`.
  `column` - The position in the record, 0 if to be set later.

Method Detail

### computeStatistics

    public void computeStatistics(java.lang.Object inValue)

  Add unique symbols to a symbol table and maintain a dictionary of legal values. This is used to create symbol tables for translate filters or convert Strings to numeric values.

  Specified by:
    `computeStatistics` in interface `AbleField`

### getNumericValue

    public double getNumericValue(java.lang.Object inValue)

  Translate a value into an index in the dictionary. The first dictionary element has numeric value 1. Useful for converting to one-of-N code.

  Specified by:
    `getNumericValue` in interface `AbleField`
  Returns:
    An index position in the range of 1 to N. A value of 0 indicates the value is absent.

### getNormalizedSize

    public int getNormalizedSize()

  Return the number of unique categories for 1 of N code.

  Specified by:
    `getNormalizedSize` in interface `AbleField`

### getInputTranslateTemplate

    public AbleTranslateTemplate getInputTranslateTemplate()

  Provide an input translate template for this field.
  - if the field usage is input, create a one of N code.
  - if the field usage is output, create a one of N code.
  - if the field usage is ignore, then ignore it.
  If field only contains 2 discrete values, treat it as a single binary template.

  Specified by:
    `getInputTranslateTemplate` in interface `AbleField`
  Returns:
    the fully configured AbleTranslateTemplate.

### getOutputTranslateTemplate

    public AbleTranslateTemplate getOutputTranslateTemplate()

  Provide an output translate template for this field.

  Specified by:
    `getOutputTranslateTemplate` in interface `AbleField`
  Returns:
    the fully configured AbleTranslateTemplate if usage is output, and null otherwise.

### setColumn

    public void setColumn(int col)

  Description copied from interface: `AbleField`
  Set the index position in the record, based on field definition order.

  Specified by:
    `setColumn` in interface `AbleField`

### getColumn

    public int getColumn()

  Description copied from interface: `AbleField`
  Get the column index position of this field in a record.

  Specified by:
    `getColumn` in interface `AbleField`

### getDataTypeString

    public java.lang.String getDataTypeString()

  Description copied from interface: `AbleField`
  Get the data type of this field as a string - "continuous" for example. Data types are listed in `AbleData.DataType(int)`.

  Specified by:
    `getDataTypeString` in interface `AbleField`

### getUsageString

    public java.lang.String getUsageString()

  Description copied from interface: `AbleField`
  Get the usage type of this field as a string - "input" for example. Usage types are listed in `AbleData.UsageType(java.lang.String)`.

  Specified by:
    `getUsageString` in interface `AbleField`

### getUsage

    public int getUsage()

  Description copied from interface: `AbleField`
  Get the usage type of this field - "input" for example. Usage types are listed in `AbleData.UsageType(java.lang.String)`.

  Specified by:
    `getUsage` in interface `AbleField`

### setUsage

    public void setUsage(java.lang.String usage)

  Description copied from interface: `AbleField`
  Set the usage type of this from a string - "input" for example. Usage types are listed in `AbleData.UsageType(java.lang.String)`.

  Specified by:
    `setUsage` in interface `AbleField`

### getMap

    public java.util.Map getMap()

  Description copied from interface: `AbleField`
  Get the Map of all unique values that are possible for this field. The Map's key should be a string representation of an integer, and the object should be the value itself. Fields which do not have a unique number of values should return null.

  Specified by:
    `getMap` in interface `AbleField`

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005